OpenVDB: RootNode< ChildType > Class Template Reference

OpenVDB 5.1.0

Classes | Public Types | Public Member Functions | Static Public Member Functions | Static Public Attributes | Friends | List of all members
RootNode< ChildType > Class Template Reference

`#include <RootNode.h>`

## Classes
struct | SameConfiguration
| SameConfiguration<OtherNodeType>::value is `true` if and only if OtherNodeType is the type of a RootNode whose ChildNodeType has the same configuration as this node's ChildNodeType. More...
struct | ValueConverter
| ValueConverter<T>::Type is the type of a RootNode having the same child hierarchy as this node but a different value type, T. More...

## Public Types
using | ChildNodeType = ChildType
using | LeafNodeType = typename ChildType::LeafNodeType
using | ValueType = typename ChildType::ValueType
using | BuildType = typename ChildType::BuildType
using | NodeChainType = typename NodeChain< RootNode, LEVEL >::Type
| NodeChainType is a list of this tree's node types, from LeafNodeType to RootNode. More...
using | ChildOnIter = ChildIter< RootNode, MapIter, ChildOnPred, ChildType >
using | ChildOnCIter = ChildIter< const RootNode, MapCIter, ChildOnPred, const ChildType >
using | ChildOffIter = ValueIter< RootNode, MapIter, ChildOffPred, const ValueType >
using | ChildOffCIter = ValueIter< const RootNode, MapCIter, ChildOffPred, ValueType >
using | ChildAllIter = DenseIter< RootNode, MapIter, ChildType, ValueType >
using | ChildAllCIter = DenseIter< const RootNode, MapCIter, const ChildType, const ValueType >
using | ValueOnIter = ValueIter< RootNode, MapIter, ValueOnPred, ValueType >
using | ValueOnCIter = ValueIter< const RootNode, MapCIter, ValueOnPred, const ValueType >
using | ValueOffIter = ValueIter< RootNode, MapIter, ValueOffPred, ValueType >
using | ValueOffCIter = ValueIter< const RootNode, MapCIter, ValueOffPred, const ValueType >
using | ValueAllIter = ValueIter< RootNode, MapIter, ValueAllPred, ValueType >
using | ValueAllCIter = ValueIter< const RootNode, MapCIter, ValueAllPred, const ValueType >

## Public Member Functions
| RootNode ()
| Construct a new tree with a background value of 0. More...
| RootNode (const ValueType &background)
| Construct a new tree with the given background value. More...
| RootNode (const RootNode &other)
template<typename OtherChildType >
| RootNode (const RootNode< OtherChildType > &other)
| Construct a new tree that reproduces the topology and active states of a tree of a different ValueType but the same configuration (levels, node dimensions and branching factors). Cast the other tree's values to this tree's ValueType. More...
template<typename OtherChildType >
| RootNode (const RootNode< OtherChildType > &other, const ValueType &background, const ValueType &foreground, TopologyCopy)
| Construct a new tree that reproduces the topology and active states of another tree (which may have a different ValueType), but not the other tree's values. More...
template<typename OtherChildType >
| RootNode (const RootNode< OtherChildType > &other, const ValueType &background, TopologyCopy)
| Construct a new tree that reproduces the topology and active states of another tree (which may have a different ValueType), but not the other tree's values. All tiles and voxels in the new tree are set to background regardless of their active states in the other tree. More...
RootNode & | operator= (const RootNode &other)
| Copy a root node of the same type as this node. More...
template<typename OtherChildType >
RootNode & | operator= (const RootNode< OtherChildType > &other)
| Copy a root node of the same tree configuration as this node but a different ValueType. More...
| ~RootNode ()
ChildOnCIter | cbeginChildOn () const
ChildOffCIter | cbeginChildOff () const
ChildAllCIter | cbeginChildAll () const
ChildOnCIter | beginChildOn () const
ChildOffCIter | beginChildOff () const
ChildAllCIter | beginChildAll () const
ChildOnIter | beginChildOn ()
ChildOffIter | beginChildOff ()
ChildAllIter | beginChildAll ()
ValueOnCIter | cbeginValueOn () const
ValueOffCIter | cbeginValueOff () const
ValueAllCIter | cbeginValueAll () const
ValueOnCIter | beginValueOn () const
ValueOffCIter | beginValueOff () const
ValueAllCIter | beginValueAll () const
ValueOnIter | beginValueOn ()
ValueOffIter | beginValueOff ()
ValueAllIter | beginValueAll ()
Index64 | memUsage () const
| Return the total amount of memory in bytes occupied by this node and its children. More...
void | evalActiveBoundingBox (CoordBBox &bbox, bool visitVoxels=true) const
| Expand the specified bbox so it includes the active tiles of this root node as well as all the active values in its child nodes. If visitVoxels is false LeafNodes will be approximated as dense, i.e. with all voxels active. Else the individual active voxels are visited to produce a tight bbox. More...
void | setBackground (const ValueType &value, bool updateChildNodes)
| Change inactive tiles or voxels with a value equal to +/- the old background to the specified value (with the same sign). Active values are unchanged. More...
const ValueType & | background () const
| Return this node's background value. More...
bool | isBackgroundTile (const Tile &) const
| Return `true` if the given tile is inactive and has the background value. More...
size_t | numBackgroundTiles () const
| Return the number of background tiles. More...
size_t | eraseBackgroundTiles ()
| Remove all background tiles. More...
void | clear ()
bool | empty () const
| Return `true` if this node's table is either empty or contains only background tiles. More...
bool | expand (const Coord &xyz)
| Expand this node's table so that (x, y, z) is included in the index range. More...
Index | getTableSize () const
| Return the number of entries in this node's table. More...
Index | getWidth () const
Index | getHeight () const
Index | getDepth () const
Coord | getMinIndex () const
| Return the smallest index of the current tree. More...
Coord | getMaxIndex () const
| Return the largest index of the current tree. More...
void | getIndexRange (CoordBBox &bbox) const
| Return the current index range. Both min and max are inclusive. More...
template<typename OtherChildType >
bool | hasSameTopology (const RootNode< OtherChildType > &other) const
| Return `true` if the given tree has the same node and active value topology as this tree (but possibly a different `ValueType`). More...
Index32 | leafCount () const
Index32 | nonLeafCount () const
Index64 | onVoxelCount () const
Index64 | offVoxelCount () const
Index64 | onLeafVoxelCount () const
Index64 | offLeafVoxelCount () const
Index64 | onTileCount () const
bool | isValueOn (const Coord &xyz) const
bool | hasActiveTiles () const
| Return `true` if this root node, or any of its child nodes, have active tiles. More...
const ValueType & | getValue (const Coord &xyz) const
bool | probeValue (const Coord &xyz, ValueType &value) const
int | getValueDepth (const Coord &xyz) const
| Return the tree depth (0 = root) at which the value of voxel (x, y, z) resides. More...
void | setActiveState (const Coord &xyz, bool on)
| Set the active state of the voxel at the given coordinates but don't change its value. More...
void | setValueOnly (const Coord &xyz, const ValueType &value)
| Set the value of the voxel at the given coordinates but don't change its active state. More...
void | setValueOn (const Coord &xyz, const ValueType &value)
| Set the value of the voxel at the given coordinates and mark the voxel as active. More...
void | setValueOff (const Coord &xyz)
| Mark the voxel at the given coordinates as inactive but don't change its value. More...
void | setValueOff (const Coord &xyz, const ValueType &value)
| Set the value of the voxel at the given coordinates and mark the voxel as inactive. More...
template<typename ModifyOp >
void | modifyValue (const Coord &xyz, const ModifyOp &op)
| Apply a functor to the value of the voxel at the given coordinates and mark the voxel as active. More...
template<typename ModifyOp >
void | modifyValueAndActiveState (const Coord &xyz, const ModifyOp &op)
| Apply a functor to the voxel at the given coordinates. More...
void | denseFill (const CoordBBox &bbox, const ValueType &value, bool active=true)
| Set all voxels within a given axis-aligned box to a constant value and ensure that those voxels are all represented at the leaf level. More...
void | voxelizeActiveTiles (bool threaded=true)
| Densify active tiles, i.e., replace them with leaf-level active voxels. More...
template<typename DenseT >
void | copyToDense (const CoordBBox &bbox, DenseT &dense) const
| Copy into a dense grid the values of all voxels, both active and inactive, that intersect a given bounding box. More...
bool | writeTopology (std::ostream &, bool toHalf=false) const
bool | readTopology (std::istream &, bool fromHalf=false)
void | writeBuffers (std::ostream &, bool toHalf=false) const
void | readBuffers (std::istream &, bool fromHalf=false)
void | readBuffers (std::istream &, const CoordBBox &, bool fromHalf=false)
template<typename AccessorT >
const ValueType & | getValueAndCache (const Coord &xyz, AccessorT &) const
template<typename AccessorT >
bool | isValueOnAndCache (const Coord &xyz, AccessorT &) const
template<typename AccessorT >
void | setValueAndCache (const Coord &xyz, const ValueType &value, AccessorT &)
template<typename AccessorT >
void | setValueOnlyAndCache (const Coord &xyz, const ValueType &value, AccessorT &)
template<typename ModifyOp , typename AccessorT >
void | modifyValueAndCache (const Coord &xyz, const ModifyOp &op, AccessorT &)
template<typename ModifyOp , typename AccessorT >
void | modifyValueAndActiveStateAndCache (const Coord &xyz, const ModifyOp &op, AccessorT &)
template<typename AccessorT >
void | setValueOffAndCache (const Coord &xyz, const ValueType &value, AccessorT &)
template<typename AccessorT >
void | setActiveStateAndCache (const Coord &xyz, bool on, AccessorT &)
template<typename AccessorT >
bool | probeValueAndCache (const Coord &xyz, ValueType &value, AccessorT &) const
template<typename AccessorT >
int | getValueDepthAndCache (const Coord &xyz, AccessorT &) const
void | clip (const CoordBBox &)
| Set all voxels that lie outside the given axis-aligned box to the background. More...
void | prune (const ValueType &tolerance=zeroVal< ValueType >())
| Reduce the memory footprint of this tree by replacing with tiles any nodes whose values are all the same (optionally to within a tolerance) and have the same active state. More...
void | addLeaf (LeafNodeType *leaf)
| Add the given leaf node to this tree, creating a new branch if necessary. If a leaf node with the same origin already exists, replace it. More...
template<typename AccessorT >
void | addLeafAndCache (LeafNodeType *leaf, AccessorT &)
| Same as addLeaf() but, if necessary, update the given accessor with pointers to the nodes along the path from the root node to the node containing the coordinate. More...
template<typename NodeT >
NodeT * | stealNode (const Coord &xyz, const ValueType &value, bool state)
| Return a pointer to the node of type `NodeT` that contains voxel (x, y, z) and replace it with a tile of the specified value and state. If no such node exists, leave the tree unchanged and return `nullptr`. More...
void | addTile (const Coord &xyz, const ValueType &value, bool state)
| Add a tile containing voxel (x, y, z) at the root level, deleting the existing branch if necessary. More...
void | addTile (Index level, const Coord &xyz, const ValueType &value, bool state)
| Add a tile containing voxel (x, y, z) at the specified tree level, creating a new branch if necessary. Delete any existing lower-level nodes that contain (x, y, z). More...
template<typename AccessorT >
void | addTileAndCache (Index level, const Coord &xyz, const ValueType &, bool state, AccessorT &)
| Same as addTile() but, if necessary, update the given accessor with pointers to the nodes along the path from the root node to the node containing the coordinate. More...
LeafNodeType * | touchLeaf (const Coord &xyz)
| Return a pointer to the leaf node that contains voxel (x, y, z). If no such node exists, create one that preserves the values and active states of all voxels. More...
template<typename AccessorT >
LeafNodeType * | touchLeafAndCache (const Coord &xyz, AccessorT &acc)
| Same as touchLeaf() but, if necessary, update the given accessor with pointers to the nodes along the path from the root node to the node containing the coordinate. More...
template<MergePolicy Policy>
void | merge (RootNode &other)
| Efficiently merge another tree into this tree using one of several schemes. More...
template<typename OtherChildType >
void | topologyUnion (const RootNode< OtherChildType > &other)
| Union this tree's set of active values with the active values of the other tree, whose `ValueType` may be different. More...
template<typename OtherChildType >
void | topologyIntersection (const RootNode< OtherChildType > &other)
| Intersects this tree's set of active values with the active values of the other tree, whose `ValueType` may be different. More...
template<typename OtherChildType >
void | topologyDifference (const RootNode< OtherChildType > &other)
| Difference this tree's set of active values with the active values of the other tree, whose `ValueType` may be different. So a resulting voxel will be active only if the original voxel is active in this tree and inactive in the other tree. More...
template<typename CombineOp >
void | combine (RootNode &other, CombineOp &, bool prune=false)
template<typename CombineOp , typename OtherRootNode >
void | combine2 (const RootNode &other0, const OtherRootNode &other1, CombineOp &op, bool prune=false)
template<typename BBoxOp >
void | visitActiveBBox (BBoxOp &) const
| Call the templated functor BBoxOp with bounding box information for all active tiles and leaf nodes in the tree. An additional level argument is provided for each callback. More...
template<typename VisitorOp >
void | visit (VisitorOp &)
template<typename VisitorOp >
void | visit (VisitorOp &) const
template<typename OtherRootNodeType , typename VisitorOp >
void | visit2 (OtherRootNodeType &other, VisitorOp &)
template<typename OtherRootNodeType , typename VisitorOp >
void | visit2 (OtherRootNodeType &other, VisitorOp &) const
template<typename OtherChildType >
RootNode< ChildT > & | operator= (const RootNode< OtherChildType > &other)
template<typename AccessorT >
const ChildT::ValueType & | getValueAndCache (const Coord &xyz, AccessorT &acc) const
template<typename AccessorT >
ChildT::LeafNodeType * | touchLeafAndCache (const Coord &xyz, AccessorT &acc)
template<typename AccessorT >
ChildT::LeafNodeType * | probeLeafAndCache (const Coord &xyz, AccessorT &acc)
template<typename AccessorT >
const ChildT::LeafNodeType * | probeConstLeafAndCache (const Coord &xyz, AccessorT &acc) const
template<typename AccessorT >
const ChildT::LeafNodeType * | probeLeafAndCache (const Coord &xyz, AccessorT &acc) const
bool | isBackgroundTile (const MapIter &) const
| Return `true` if the given iterator points to an inactive tile with the background value. More...
bool | isBackgroundTile (const MapCIter &) const
| Return `true` if the given iterator points to an inactive tile with the background value. More...
void | fill (const CoordBBox &bbox, const ValueType &value, bool active=true)
| Set all voxels within a given axis-aligned box to a constant value. More...
void | sparseFill (const CoordBBox &bbox, const ValueType &value, bool active=true)
| Set all voxels within a given axis-aligned box to a constant value. More...
template<typename NodeT >
NodeT * | probeNode (const Coord &xyz)
| Return a pointer to the node that contains voxel (x, y, z). If no such node exists, return `nullptr`. More...
template<typename NodeT >
const NodeT * | probeConstNode (const Coord &xyz) const
| Return a pointer to the node that contains voxel (x, y, z). If no such node exists, return `nullptr`. More...
template<typename NodeT , typename AccessorT >
NodeT * | probeNodeAndCache (const Coord &xyz, AccessorT &acc)
| Same as probeNode() but, if necessary, update the given accessor with pointers to the nodes along the path from the root node to the node containing the coordinate. More...
template<typename NodeT , typename AccessorT >
const NodeT * | probeConstNodeAndCache (const Coord &xyz, AccessorT &acc) const
| Same as probeNode() but, if necessary, update the given accessor with pointers to the nodes along the path from the root node to the node containing the coordinate. More...
LeafNodeType * | probeLeaf (const Coord &xyz)
| Return a pointer to the leaf node that contains voxel (x, y, z). If no such node exists, return `nullptr`. More...
const LeafNodeType * | probeConstLeaf (const Coord &xyz) const
| Return a pointer to the leaf node that contains voxel (x, y, z). If no such node exists, return `nullptr`. More...
const LeafNodeType * | probeLeaf (const Coord &xyz) const
| Return a pointer to the leaf node that contains voxel (x, y, z). If no such node exists, return `nullptr`. More...
template<typename AccessorT >
LeafNodeType * | probeLeafAndCache (const Coord &xyz, AccessorT &acc)
| Same as probeLeaf() but, if necessary, update the given accessor with pointers to the nodes along the path from the root node to the node containing the coordinate. More...
template<typename AccessorT >
const LeafNodeType * | probeConstLeafAndCache (const Coord &xyz, AccessorT &acc) const
| Same as probeLeaf() but, if necessary, update the given accessor with pointers to the nodes along the path from the root node to the node containing the coordinate. More...
template<typename AccessorT >
const LeafNodeType * | probeLeafAndCache (const Coord &xyz, AccessorT &acc) const
| Same as probeLeaf() but, if necessary, update the given accessor with pointers to the nodes along the path from the root node to the node containing the coordinate. More...
template<typename ArrayT >
void | getNodes (ArrayT &array)
| Adds all nodes of a certain type to a container with the following API: More...
template<typename ArrayT >
void | getNodes (ArrayT &array) const
| Adds all nodes of a certain type to a container with the following API: More...
template<typename ArrayT >
void | stealNodes (ArrayT &array, const ValueType &value, bool state)
| Steals all nodes of a certain type from the tree and adds them to a container with the following API: More...
template<typename ArrayT >
void | stealNodes (ArrayT &array)
| Steals all nodes of a certain type from the tree and adds them to a container with the following API: More...

## Static Public Member Functions
static CoordBBox | getNodeBoundingBox ()
| Return the bounding box of this RootNode, i.e., an infinite bounding box. More...
static Index | getLevel ()
static void | getNodeLog2Dims (std::vector< Index > &dims)
static Index | getChildDim ()
template<typename OtherChildType >
static bool | hasSameConfiguration (const RootNode< OtherChildType > &other)
| Return `false` if the other node's dimensions don't match this node's. More...
template<typename OtherChildType >
static bool | hasCompatibleValueType (const RootNode< OtherChildType > &other)

## Static Public Attributes
static const Index | LEVEL = 1 + ChildType::LEVEL

## Friends
template<typename >
class | RootNode
template<typename , typename , bool >
struct | RootNodeCopyHelper
template<typename , typename , typename , bool >
struct | RootNodeCombineHelper

## Member Typedef Documentation

## ◆ BuildType

using BuildType = typename ChildType::BuildType

## ◆ ChildAllCIter

using ChildAllCIter = DenseIter<const RootNode, MapCIter, const ChildType, const ValueType>

## ◆ ChildAllIter

using ChildAllIter = DenseIter<RootNode, MapIter, ChildType, ValueType>

## ◆ ChildNodeType

using ChildNodeType = ChildType

## ◆ ChildOffCIter

using ChildOffCIter = ValueIter<const RootNode, MapCIter, ChildOffPred, ValueType>

## ◆ ChildOffIter

using ChildOffIter = ValueIter<RootNode, MapIter, ChildOffPred, const ValueType>

## ◆ ChildOnCIter

using ChildOnCIter = ChildIter<const RootNode, MapCIter, ChildOnPred, const ChildType>

## ◆ ChildOnIter

using ChildOnIter = ChildIter<RootNode, MapIter, ChildOnPred, ChildType>

## ◆ LeafNodeType

using LeafNodeType = typename ChildType::LeafNodeType

## ◆ NodeChainType

using NodeChainType = typename NodeChain<RootNode, LEVEL>::Type

NodeChainType is a list of this tree's node types, from LeafNodeType to RootNode.

## ◆ ValueAllCIter

using ValueAllCIter = ValueIter<const RootNode, MapCIter, ValueAllPred, const ValueType>

## ◆ ValueAllIter

using ValueAllIter = ValueIter<RootNode, MapIter, ValueAllPred, ValueType>

## ◆ ValueOffCIter

using ValueOffCIter = ValueIter<const RootNode, MapCIter, ValueOffPred, const ValueType>

## ◆ ValueOffIter

using ValueOffIter = ValueIter<RootNode, MapIter, ValueOffPred, ValueType>

## ◆ ValueOnCIter

using ValueOnCIter = ValueIter<const RootNode, MapCIter, ValueOnPred, const ValueType>

## ◆ ValueOnIter

using ValueOnIter = ValueIter<RootNode, MapIter, ValueOnPred, ValueType>

## ◆ ValueType

using ValueType = typename ChildType::ValueType

## Constructor & Destructor Documentation

## ◆ RootNode() [1/6]

RootNode | ( |  | ) |
| inline

Construct a new tree with a background value of 0.

## ◆ RootNode() [2/6]

RootNode | ( | const ValueType & | background | ) |
| inlineexplicit

Construct a new tree with the given background value.

## ◆ RootNode() [3/6]

RootNode | ( | const RootNode< ChildType > & | other | ) |
| inline

## ◆ RootNode() [4/6]

RootNode | ( | const RootNode< OtherChildType > & | other | ) |
| inlineexplicit

Construct a new tree that reproduces the topology and active states of a tree of a different ValueType but the same configuration (levels, node dimensions and branching factors). Cast the other tree's values to this tree's ValueType.

Exceptions

  TypeError | if the other tree's configuration doesn't match this tree's or if this tree's ValueType is not constructible from the other tree's ValueType.

## ◆ RootNode() [5/6]

RootNode | ( | const RootNode< OtherChildType > & | other,
|  | const ValueType & | background,
|  | const ValueType & | foreground,
|  | TopologyCopy |
| ) |  |
| inline

Construct a new tree that reproduces the topology and active states of another tree (which may have a different ValueType), but not the other tree's values.

All tiles and voxels that are active in the other tree are set to foreground in the new tree, and all inactive tiles and voxels are set to background.

Parameters

  other | the root node of a tree having (possibly) a different ValueType
  background | the value to which inactive tiles and voxels are initialized
  foreground | the value to which active tiles and voxels are initialized

Exceptions

  TypeError | if the other tree's configuration doesn't match this tree's.

## ◆ RootNode() [6/6]

RootNode | ( | const RootNode< OtherChildType > & | other,
|  | const ValueType & | background,
|  | TopologyCopy |
| ) |  |
| inline

Construct a new tree that reproduces the topology and active states of another tree (which may have a different ValueType), but not the other tree's values. All tiles and voxels in the new tree are set to background regardless of their active states in the other tree.

Parameters

  other | the root node of a tree having (possibly) a different ValueType
  background | the value to which inactive tiles and voxels are initialized

Note
  This copy constructor is generally faster than the one that takes both a foreground and a background value. Its main application is in multithreaded operations where the topology of the output tree exactly matches the input tree.

Exceptions

  TypeError | if the other tree's configuration doesn't match this tree's.

## ◆ ~RootNode()

~RootNode | ( |  | ) |
| inline

## Member Function Documentation

## ◆ addLeaf()

void addLeaf | ( | LeafNodeType * | leaf | ) |
| inline

Add the given leaf node to this tree, creating a new branch if necessary. If a leaf node with the same origin already exists, replace it.

## ◆ addLeafAndCache()

void addLeafAndCache | ( | LeafNodeType * | leaf,
|  | AccessorT & | acc
| ) |  |
| inline

Same as addLeaf() but, if necessary, update the given accessor with pointers to the nodes along the path from the root node to the node containing the coordinate.

## ◆ addTile() [1/2]

void addTile | ( | const Coord & | xyz,
|  | const ValueType & | value,
|  | bool | state
| ) |  |
| inline

Add a tile containing voxel (x, y, z) at the root level, deleting the existing branch if necessary.

## ◆ addTile() [2/2]

void addTile | ( | Index | level,
|  | const Coord & | xyz,
|  | const ValueType & | value,
|  | bool | state
| ) |  |
| inline

Add a tile containing voxel (x, y, z) at the specified tree level, creating a new branch if necessary. Delete any existing lower-level nodes that contain (x, y, z).

## ◆ addTileAndCache()

void addTileAndCache | ( | Index | level,
|  | const Coord & | xyz,
|  | const ValueType & | value,
|  | bool | state,
|  | AccessorT & | acc
| ) |  |
| inline

Same as addTile() but, if necessary, update the given accessor with pointers to the nodes along the path from the root node to the node containing the coordinate.

## ◆ background()

const ValueType& background | ( |  | ) | const
| inline

Return this node's background value.

## ◆ beginChildAll() [1/2]

ChildAllCIter beginChildAll | ( |  | ) | const
| inline

## ◆ beginChildAll() [2/2]

ChildAllIter beginChildAll | ( |  | ) |
| inline

## ◆ beginChildOff() [1/2]

ChildOffCIter beginChildOff | ( |  | ) | const
| inline

## ◆ beginChildOff() [2/2]

ChildOffIter beginChildOff | ( |  | ) |
| inline

## ◆ beginChildOn() [1/2]

ChildOnCIter beginChildOn | ( |  | ) | const
| inline

## ◆ beginChildOn() [2/2]

ChildOnIter beginChildOn | ( |  | ) |
| inline

## ◆ beginValueAll() [1/2]

ValueAllCIter beginValueAll | ( |  | ) | const
| inline

## ◆ beginValueAll() [2/2]

ValueAllIter beginValueAll | ( |  | ) |
| inline

## ◆ beginValueOff() [1/2]

ValueOffCIter beginValueOff | ( |  | ) | const
| inline

## ◆ beginValueOff() [2/2]

ValueOffIter beginValueOff | ( |  | ) |
| inline

## ◆ beginValueOn() [1/2]

ValueOnCIter beginValueOn | ( |  | ) | const
| inline

## ◆ beginValueOn() [2/2]

ValueOnIter beginValueOn | ( |  | ) |
| inline

## ◆ cbeginChildAll()

ChildAllCIter cbeginChildAll | ( |  | ) | const
| inline

## ◆ cbeginChildOff()

ChildOffCIter cbeginChildOff | ( |  | ) | const
| inline

## ◆ cbeginChildOn()

ChildOnCIter cbeginChildOn | ( |  | ) | const
| inline

## ◆ cbeginValueAll()

ValueAllCIter cbeginValueAll | ( |  | ) | const
| inline

## ◆ cbeginValueOff()

ValueOffCIter cbeginValueOff | ( |  | ) | const
| inline

## ◆ cbeginValueOn()

ValueOnCIter cbeginValueOn | ( |  | ) | const
| inline

## ◆ clear()

void clear | ( |  | ) |
| inline

## ◆ clip()

void clip | ( | const CoordBBox & | clipBBox | ) |
| inline

Set all voxels that lie outside the given axis-aligned box to the background.

## ◆ combine()

void combine | ( | RootNode< ChildType > & | other,
|  | CombineOp & | op,
|  | bool | prune = `false`
| ) |  |
| inline

## ◆ combine2()

void combine2 | ( | const RootNode< ChildType > & | other0,
|  | const OtherRootNode< ChildType > & | other1,
|  | CombineOp & | op,
|  | bool | prune = `false`
| ) |  |
| inline

## ◆ copyToDense()

void copyToDense | ( | const CoordBBox & | bbox,
|  | DenseT & | dense
| ) |  | const
| inline

Copy into a dense grid the values of all voxels, both active and inactive, that intersect a given bounding box.

Parameters

  bbox | inclusive bounding box of the voxels to be copied into the dense grid
  dense | dense grid with a stride in z of one (see tools::Dense in tools/Dense.h for the required API)

## ◆ denseFill()

void denseFill | ( | const CoordBBox & | bbox,
|  | const ValueType & | value,
|  | bool | active = `true`
| ) |  |
| inline

Set all voxels within a given axis-aligned box to a constant value and ensure that those voxels are all represented at the leaf level.

Parameters

  bbox | inclusive coordinates of opposite corners of an axis-aligned box.
  value | the value to which to set voxels within the box.
  active | if true, mark voxels within the box as active, otherwise mark them as inactive.

See also
  voxelizeActiveTiles()

## ◆ empty()

bool empty | ( |  | ) | const
| inline

Return `true` if this node's table is either empty or contains only background tiles.

## ◆ eraseBackgroundTiles()

size_t eraseBackgroundTiles | ( |  | ) |
| inline

Remove all background tiles.

Returns
  the number of tiles removed.

## ◆ evalActiveBoundingBox()

void evalActiveBoundingBox | ( | CoordBBox & | bbox,
|  | bool | visitVoxels = `true`
| ) |  | const
| inline

Expand the specified bbox so it includes the active tiles of this root node as well as all the active values in its child nodes. If visitVoxels is false LeafNodes will be approximated as dense, i.e. with all voxels active. Else the individual active voxels are visited to produce a tight bbox.

## ◆ expand()

bool expand | ( | const Coord & | xyz | ) |
| inline

Expand this node's table so that (x, y, z) is included in the index range.

Returns
  `true` if an expansion was performed (i.e., if (x, y, z) was not already included in the index range).

## ◆ fill()

void fill | ( | const CoordBBox & | bbox,
|  | const ValueType & | value,
|  | bool | active = `true`
| ) |  |
| inline

Set all voxels within a given axis-aligned box to a constant value.

Parameters

  bbox | inclusive coordinates of opposite corners of an axis-aligned box
  value | the value to which to set voxels within the box
  active | if true, mark voxels within the box as active, otherwise mark them as inactive

Note
  This operation generates a sparse, but not always optimally sparse, representation of the filled box. Follow fill operations with a prune() operation for optimal sparseness.

## ◆ getChildDim()

static Index getChildDim | ( |  | ) |
| inlinestatic

## ◆ getDepth()

Index getDepth | ( |  | ) | const
| inline

## ◆ getHeight()

Index getHeight | ( |  | ) | const
| inline

## ◆ getIndexRange()

void getIndexRange | ( | CoordBBox & | bbox | ) | const
| inline

Return the current index range. Both min and max are inclusive.

## ◆ getLevel()

static Index getLevel | ( |  | ) |
| inlinestatic

## ◆ getMaxIndex()

Coord getMaxIndex | ( |  | ) | const
| inline

Return the largest index of the current tree.

## ◆ getMinIndex()

Coord getMinIndex | ( |  | ) | const
| inline

Return the smallest index of the current tree.

## ◆ getNodeBoundingBox()

static CoordBBox getNodeBoundingBox | ( |  | ) |
| inlinestatic

Return the bounding box of this RootNode, i.e., an infinite bounding box.

## ◆ getNodeLog2Dims()

void getNodeLog2Dims | ( | std::vector< Index > & | dims | ) |
| inlinestatic

## ◆ getNodes() [1/2]

void getNodes | ( | ArrayT & | array | ) |
| inline

Adds all nodes of a certain type to a container with the following API:

struct ArrayT {
using value_type = ...;// defines the type of nodes to be added to the array
void push_back(value_type nodePtr);// method that add nodes to the array
};

An example of a wrapper around a c-style array is:

struct MyArray {
using value_type = LeafType*;
value_type* ptr;
MyArray(value_type* array) : ptr(array) {}
void push_back(value_type leaf) { *ptr++ = leaf; }
};

An example that constructs a list of pointer to all leaf nodes is:

std::vector<const LeafNodeType*> array;//most std contains have the required API
array.reserve(tree.leafCount());//this is a fast preallocation.
tree.getNodes(array);

## ◆ getNodes() [2/2]

void getNodes | ( | ArrayT & | array | ) | const
| inline

Adds all nodes of a certain type to a container with the following API:

struct ArrayT {
using value_type = ...;// defines the type of nodes to be added to the array
void push_back(value_type nodePtr);// method that add nodes to the array
};

An example of a wrapper around a c-style array is:

struct MyArray {
using value_type = LeafType*;
value_type* ptr;
MyArray(value_type* array) : ptr(array) {}
void push_back(value_type leaf) { *ptr++ = leaf; }
};

An example that constructs a list of pointer to all leaf nodes is:

std::vector<const LeafNodeType*> array;//most std contains have the required API
array.reserve(tree.leafCount());//this is a fast preallocation.
tree.getNodes(array);

## ◆ getTableSize()

Index getTableSize | ( |  | ) | const
| inline

Return the number of entries in this node's table.

## ◆ getValue()

const ChildT::ValueType & getValue | ( | const Coord & | xyz | ) | const
| inline

## ◆ getValueAndCache() [1/2]

const ValueType& getValueAndCache | ( | const Coord & | xyz,
|  | AccessorT & |
| ) |  | const

Return the value of the voxel at the given coordinates and, if necessary, update the accessor with pointers to the nodes along the path from the root node to the node containing the voxel.

Note
  Used internally by ValueAccessor.

## ◆ getValueAndCache() [2/2]

const ChildT::ValueType& getValueAndCache | ( | const Coord & | xyz,
|  | AccessorT & | acc
| ) |  | const
| inline

## ◆ getValueDepth()

int getValueDepth | ( | const Coord & | xyz | ) | const
| inline

Return the tree depth (0 = root) at which the value of voxel (x, y, z) resides.

If (x, y, z) isn't explicitly represented in the tree (i.e., it is implicitly a background voxel), return -1.

## ◆ getValueDepthAndCache()

int getValueDepthAndCache | ( | const Coord & | xyz,
|  | AccessorT & | acc
| ) |  | const
| inline

Return the tree depth (0 = root) at which the value of voxel (x, y, z) resides. If (x, y, z) isn't explicitly represented in the tree (i.e., it is implicitly a background voxel), return -1. If necessary, update the accessor with pointers to the nodes along the path from the root node to the node containing the voxel.

Note
  Used internally by ValueAccessor.

## ◆ getWidth()

Index getWidth | ( |  | ) | const
| inline

## ◆ hasActiveTiles()

bool hasActiveTiles | ( |  | ) | const
| inline

Return `true` if this root node, or any of its child nodes, have active tiles.

## ◆ hasCompatibleValueType()

bool hasCompatibleValueType | ( | const RootNode< OtherChildType > & | other | ) |
| inlinestatic

Return `true` if values of the other node's ValueType can be converted to values of this node's ValueType.

## ◆ hasSameConfiguration()

bool hasSameConfiguration | ( | const RootNode< OtherChildType > & | other | ) |
| inlinestatic

Return `false` if the other node's dimensions don't match this node's.

## ◆ hasSameTopology()

bool hasSameTopology | ( | const RootNode< OtherChildType > & | other | ) | const
| inline

Return `true` if the given tree has the same node and active value topology as this tree (but possibly a different `ValueType`).

## ◆ isBackgroundTile() [1/3]

bool isBackgroundTile | ( | const Tile & | tile | ) | const
| inline

Return `true` if the given tile is inactive and has the background value.

## ◆ isBackgroundTile() [2/3]

bool isBackgroundTile | ( | const MapIter & | iter | ) | const
| inline

Return `true` if the given iterator points to an inactive tile with the background value.

## ◆ isBackgroundTile() [3/3]

bool isBackgroundTile | ( | const MapCIter & | iter | ) | const
| inline

Return `true` if the given iterator points to an inactive tile with the background value.

## ◆ isValueOn()

bool isValueOn | ( | const Coord & | xyz | ) | const
| inline

## ◆ isValueOnAndCache()

bool isValueOnAndCache | ( | const Coord & | xyz,
|  | AccessorT & | acc
| ) |  | const
| inline

Return `true` if the voxel at the given coordinates is active and, if necessary, update the accessor with pointers to the nodes along the path from the root node to the node containing the voxel.

Note
  Used internally by ValueAccessor.

## ◆ leafCount()

Index32 leafCount | ( |  | ) | const
| inline

## ◆ memUsage()

Index64 memUsage | ( |  | ) | const
| inline

Return the total amount of memory in bytes occupied by this node and its children.

## ◆ merge()

void merge | ( | RootNode< ChildType > & | other | ) |
| inline

Efficiently merge another tree into this tree using one of several schemes.

This operation is primarily intended to combine trees that are mostly non-overlapping (for example, intermediate trees from computations that are parallelized across disjoint regions of space).

Note
  This operation is not guaranteed to produce an optimally sparse tree. Follow merge() with prune() for optimal sparseness.

Warning
  This operation always empties the other tree.

## ◆ modifyValue()

void modifyValue | ( | const Coord & | xyz,
|  | const ModifyOp & | op
| ) |  |
| inline

Apply a functor to the value of the voxel at the given coordinates and mark the voxel as active.

## ◆ modifyValueAndActiveState()

void modifyValueAndActiveState | ( | const Coord & | xyz,
|  | const ModifyOp & | op
| ) |  |
| inline

Apply a functor to the voxel at the given coordinates.

## ◆ modifyValueAndActiveStateAndCache()

void modifyValueAndActiveStateAndCache | ( | const Coord & | xyz,
|  | const ModifyOp & | op,
|  | AccessorT & | acc
| ) |  |
| inline

Apply a functor to the voxel at the given coordinates. If necessary, update the accessor with pointers to the nodes along the path from the root node to the node containing the voxel.

Note
  Used internally by ValueAccessor.

## ◆ modifyValueAndCache()

void modifyValueAndCache | ( | const Coord & | xyz,
|  | const ModifyOp & | op,
|  | AccessorT & | acc
| ) |  |
| inline

Apply a functor to the value of the voxel at the given coordinates and mark the voxel as active. If necessary, update the accessor with pointers to the nodes along the path from the root node to the node containing the voxel.

Note
  Used internally by ValueAccessor.

## ◆ nonLeafCount()

Index32 nonLeafCount | ( |  | ) | const
| inline

## ◆ numBackgroundTiles()

size_t numBackgroundTiles | ( |  | ) | const
| inline

Return the number of background tiles.

## ◆ offLeafVoxelCount()

Index64 offLeafVoxelCount | ( |  | ) | const
| inline

## ◆ offVoxelCount()

Index64 offVoxelCount | ( |  | ) | const
| inline

## ◆ onLeafVoxelCount()

Index64 onLeafVoxelCount | ( |  | ) | const
| inline

## ◆ onTileCount()

Index64 onTileCount | ( |  | ) | const
| inline

## ◆ onVoxelCount()

Index64 onVoxelCount | ( |  | ) | const
| inline

## ◆ operator=() [1/3]

RootNode< ChildT > & operator= | ( | const RootNode< ChildType > & | other | ) |
| inline

Copy a root node of the same type as this node.

## ◆ operator=() [2/3]

RootNode& operator= | ( | const RootNode< OtherChildType > & | other | ) |

Copy a root node of the same tree configuration as this node but a different ValueType.

Exceptions

  TypeError | if the other tree's configuration doesn't match this tree's.

Note
  This node's ValueType must be constructible from the other node's ValueType. For example, a root node with values of type float can be assigned to a root node with values of type Vec3s, because a Vec3s can be constructed from a float. But a Vec3s root node cannot be assigned to a float root node.

## ◆ operator=() [3/3]

RootNode<ChildT>& operator= | ( | const RootNode< OtherChildType > & | other | ) |
| inline

## ◆ probeConstLeaf()

const ChildT::LeafNodeType * probeConstLeaf | ( | const Coord & | xyz | ) | const
| inline

Return a pointer to the leaf node that contains voxel (x, y, z). If no such node exists, return `nullptr`.

## ◆ probeConstLeafAndCache() [1/2]

const LeafNodeType* probeConstLeafAndCache | ( | const Coord & | xyz,
|  | AccessorT & | acc
| ) |  | const

Same as probeLeaf() but, if necessary, update the given accessor with pointers to the nodes along the path from the root node to the node containing the coordinate.

## ◆ probeConstLeafAndCache() [2/2]

const ChildT::LeafNodeType* probeConstLeafAndCache | ( | const Coord & | xyz,
|  | AccessorT & | acc
| ) |  | const
| inline

## ◆ probeConstNode()

const NodeT * probeConstNode | ( | const Coord & | xyz | ) | const
| inline

Return a pointer to the node that contains voxel (x, y, z). If no such node exists, return `nullptr`.

## ◆ probeConstNodeAndCache()

const NodeT * probeConstNodeAndCache | ( | const Coord & | xyz,
|  | AccessorT & | acc
| ) |  | const
| inline

Same as probeNode() but, if necessary, update the given accessor with pointers to the nodes along the path from the root node to the node containing the coordinate.

## ◆ probeLeaf() [1/2]

ChildT::LeafNodeType * probeLeaf | ( | const Coord & | xyz | ) |
| inline

Return a pointer to the leaf node that contains voxel (x, y, z). If no such node exists, return `nullptr`.

## ◆ probeLeaf() [2/2]

const LeafNodeType* probeLeaf | ( | const Coord & | xyz | ) | const

Return a pointer to the leaf node that contains voxel (x, y, z). If no such node exists, return `nullptr`.

## ◆ probeLeafAndCache() [1/4]

LeafNodeType* probeLeafAndCache | ( | const Coord & | xyz,
|  | AccessorT & | acc
| ) |  |

Same as probeLeaf() but, if necessary, update the given accessor with pointers to the nodes along the path from the root node to the node containing the coordinate.

## ◆ probeLeafAndCache() [2/4]

const LeafNodeType* probeLeafAndCache | ( | const Coord & | xyz,
|  | AccessorT & | acc
| ) |  | const

Same as probeLeaf() but, if necessary, update the given accessor with pointers to the nodes along the path from the root node to the node containing the coordinate.

## ◆ probeLeafAndCache() [3/4]

ChildT::LeafNodeType* probeLeafAndCache | ( | const Coord & | xyz,
|  | AccessorT & | acc
| ) |  |
| inline

## ◆ probeLeafAndCache() [4/4]

const ChildT::LeafNodeType* probeLeafAndCache | ( | const Coord & | xyz,
|  | AccessorT & | acc
| ) |  | const
| inline

## ◆ probeNode()

NodeT * probeNode | ( | const Coord & | xyz | ) |
| inline

Return a pointer to the node that contains voxel (x, y, z). If no such node exists, return `nullptr`.

## ◆ probeNodeAndCache()

NodeT * probeNodeAndCache | ( | const Coord & | xyz,
|  | AccessorT & | acc
| ) |  |
| inline

Same as probeNode() but, if necessary, update the given accessor with pointers to the nodes along the path from the root node to the node containing the coordinate.

## ◆ probeValue()

bool probeValue | ( | const Coord & | xyz,
|  | ValueType & | value
| ) |  | const
| inline

## ◆ probeValueAndCache()

bool probeValueAndCache | ( | const Coord & | xyz,
|  | ValueType & | value,
|  | AccessorT & | acc
| ) |  | const
| inline

Return, in value, the value of the voxel at the given coordinates and, if necessary, update the accessor with pointers to the nodes along the path from the root node to the node containing the voxel.

Returns
  `true` if the voxel at the given coordinates is active

Note
  Used internally by ValueAccessor.

## ◆ prune()

void prune | ( | const ValueType & | tolerance = `zeroVal<ValueType>()` | ) |
| inline

Reduce the memory footprint of this tree by replacing with tiles any nodes whose values are all the same (optionally to within a tolerance) and have the same active state.

Note
  Consider instead using tools::prune which is multi-threaded!

## ◆ readBuffers() [1/2]

void readBuffers | ( | std::istream & | is,
|  | bool | fromHalf = `false`
| ) |  |
| inline

## ◆ readBuffers() [2/2]

void readBuffers | ( | std::istream & | is,
|  | const CoordBBox & | clipBBox,
|  | bool | fromHalf = `false`
| ) |  |
| inline

## ◆ readTopology()

bool readTopology | ( | std::istream & | is,
|  | bool | fromHalf = `false`
| ) |  |
| inline

## ◆ setActiveState()

void setActiveState | ( | const Coord & | xyz,
|  | bool | on
| ) |  |
| inline

Set the active state of the voxel at the given coordinates but don't change its value.

## ◆ setActiveStateAndCache()

void setActiveStateAndCache | ( | const Coord & | xyz,
|  | bool | on,
|  | AccessorT & | acc
| ) |  |
| inline

Set the active state of the voxel at the given coordinates without changing its value. If necessary, update the accessor with pointers to the nodes along the path from the root node to the node containing the voxel.

Note
  Used internally by ValueAccessor.

## ◆ setBackground()

void setBackground | ( | const ValueType & | value,
|  | bool | updateChildNodes
| ) |  |
| inline

Change inactive tiles or voxels with a value equal to +/- the old background to the specified value (with the same sign). Active values are unchanged.

Parameters

  value | The new background value
  updateChildNodes | If true the background values of the child nodes is also updated. Else only the background value stored in the RootNode itself is changed.

Note
  Instead of setting updateChildNodes to true, consider using tools::changeBackground or tools::changeLevelSetBackground which are multi-threaded!

## ◆ setValueAndCache()

void setValueAndCache | ( | const Coord & | xyz,
|  | const ValueType & | value,
|  | AccessorT & | acc
| ) |  |
| inline

Change the value of the voxel at the given coordinates and mark it as active. If necessary, update the accessor with pointers to the nodes along the path from the root node to the node containing the voxel.

Note
  Used internally by ValueAccessor.

## ◆ setValueOff() [1/2]

void setValueOff | ( | const Coord & | xyz | ) |
| inline

Mark the voxel at the given coordinates as inactive but don't change its value.

## ◆ setValueOff() [2/2]

void setValueOff | ( | const Coord & | xyz,
|  | const ValueType & | value
| ) |  |
| inline

Set the value of the voxel at the given coordinates and mark the voxel as inactive.

## ◆ setValueOffAndCache()

void setValueOffAndCache | ( | const Coord & | xyz,
|  | const ValueType & | value,
|  | AccessorT & | acc
| ) |  |
| inline

Change the value of the voxel at the given coordinates and mark it as inactive. If necessary, update the accessor with pointers to the nodes along the path from the root node to the node containing the voxel.

Note
  Used internally by ValueAccessor.

## ◆ setValueOn()

void setValueOn | ( | const Coord & | xyz,
|  | const ValueType & | value
| ) |  |
| inline

Set the value of the voxel at the given coordinates and mark the voxel as active.

## ◆ setValueOnly()

void setValueOnly | ( | const Coord & | xyz,
|  | const ValueType & | value
| ) |  |
| inline

Set the value of the voxel at the given coordinates but don't change its active state.

## ◆ setValueOnlyAndCache()

void setValueOnlyAndCache | ( | const Coord & | xyz,
|  | const ValueType & | value,
|  | AccessorT & | acc
| ) |  |
| inline

Set the value of the voxel at the given coordinates without changing its active state. If necessary, update the accessor with pointers to the nodes along the path from the root node to the node containing the voxel.

Note
  Used internally by ValueAccessor.

## ◆ sparseFill()

void sparseFill | ( | const CoordBBox & | bbox,
|  | const ValueType & | value,
|  | bool | active = `true`
| ) |  |
| inline

Set all voxels within a given axis-aligned box to a constant value.

Parameters

  bbox | inclusive coordinates of opposite corners of an axis-aligned box
  value | the value to which to set voxels within the box
  active | if true, mark voxels within the box as active, otherwise mark them as inactive

Note
  This operation generates a sparse, but not always optimally sparse, representation of the filled box. Follow fill operations with a prune() operation for optimal sparseness.

## ◆ stealNode()

NodeT * stealNode | ( | const Coord & | xyz,
|  | const ValueType & | value,
|  | bool | state
| ) |  |
| inline

Return a pointer to the node of type `NodeT` that contains voxel (x, y, z) and replace it with a tile of the specified value and state. If no such node exists, leave the tree unchanged and return `nullptr`.

Note
  The caller takes ownership of the node and is responsible for deleting it.

Warning
  Since this method potentially removes nodes and branches of the tree, it is important to clear the caches of all ValueAccessors associated with this tree.

## ◆ stealNodes() [1/2]

void stealNodes | ( | ArrayT & | array,
|  | const ValueType & | value,
|  | bool | state
| ) |  |
| inline

Steals all nodes of a certain type from the tree and adds them to a container with the following API:

struct ArrayT {
using value_type = ...;// defines the type of nodes to be added to the array
void push_back(value_type nodePtr);// method that add nodes to the array
};

An example of a wrapper around a c-style array is:

struct MyArray {
using value_type = LeafType*;
value_type* ptr;
MyArray(value_type* array) : ptr(array) {}
void push_back(value_type leaf) { *ptr++ = leaf; }
};

An example that constructs a list of pointer to all leaf nodes is:

std::vector<const LeafNodeType*> array;//most std contains have the required API
array.reserve(tree.leafCount());//this is a fast preallocation.
tree.stealNodes(array);

## ◆ stealNodes() [2/2]

void stealNodes | ( | ArrayT & | array | ) |
| inline

Steals all nodes of a certain type from the tree and adds them to a container with the following API:

struct ArrayT {
using value_type = ...;// defines the type of nodes to be added to the array
void push_back(value_type nodePtr);// method that add nodes to the array
};

An example of a wrapper around a c-style array is:

struct MyArray {
using value_type = LeafType*;
value_type* ptr;
MyArray(value_type* array) : ptr(array) {}
void push_back(value_type leaf) { *ptr++ = leaf; }
};

An example that constructs a list of pointer to all leaf nodes is:

std::vector<const LeafNodeType*> array;//most std contains have the required API
array.reserve(tree.leafCount());//this is a fast preallocation.
tree.stealNodes(array);

## ◆ topologyDifference()

void topologyDifference | ( | const RootNode< OtherChildType > & | other | ) |
| inline

Difference this tree's set of active values with the active values of the other tree, whose `ValueType` may be different. So a resulting voxel will be active only if the original voxel is active in this tree and inactive in the other tree.

Note
  This operation can delete branches in this grid if they overlap with active tiles in the other grid. Likewise active voxels can be turned into inactive voxels resulting in leaf nodes with no active values. Thus, it is recommended to subsequently call prune.

## ◆ topologyIntersection()

void topologyIntersection | ( | const RootNode< OtherChildType > & | other | ) |
| inline

Intersects this tree's set of active values with the active values of the other tree, whose `ValueType` may be different.

The resulting state of a value is active only if the corresponding value was already active AND if it is active in the other tree. Also, a resulting value maps to a voxel if the corresponding value already mapped to an active voxel in either of the two grids and it maps to an active tile or voxel in the other grid.

Note
  This operation can delete branches in this grid if they overlap with inactive tiles in the other grid. Likewise active voxels can be turned into inactive voxels resulting in leaf nodes with no active values. Thus, it is recommended to subsequently call prune.

## ◆ topologyUnion()

void topologyUnion | ( | const RootNode< OtherChildType > & | other | ) |
| inline

Union this tree's set of active values with the active values of the other tree, whose `ValueType` may be different.

The resulting state of a value is active if the corresponding value was already active OR if it is active in the other tree. Also, a resulting value maps to a voxel if the corresponding value already mapped to a voxel OR if it is a voxel in the other tree. Thus, a resulting value can only map to a tile if the corresponding value already mapped to a tile AND if it is a tile value in other tree.

Note
  This operation modifies only active states, not values. Specifically, active tiles and voxels in this tree are not changed, and tiles or voxels that were inactive in this tree but active in the other tree are marked as active in this tree but left with their original values.

## ◆ touchLeaf()

ChildT::LeafNodeType * touchLeaf | ( | const Coord & | xyz | ) |
| inline

Return a pointer to the leaf node that contains voxel (x, y, z). If no such node exists, create one that preserves the values and active states of all voxels.

Use this method to preallocate a static tree topology over which to safely perform multithreaded processing.

## ◆ touchLeafAndCache() [1/2]

LeafNodeType* touchLeafAndCache | ( | const Coord & | xyz,
|  | AccessorT & | acc
| ) |  |

Same as touchLeaf() but, if necessary, update the given accessor with pointers to the nodes along the path from the root node to the node containing the coordinate.

## ◆ touchLeafAndCache() [2/2]

ChildT::LeafNodeType* touchLeafAndCache | ( | const Coord & | xyz,
|  | AccessorT & | acc
| ) |  |
| inline

## ◆ visit() [1/2]

void visit | ( | VisitorOp & | op | ) |
| inline

## ◆ visit() [2/2]

void visit | ( | VisitorOp & | op | ) | const
| inline

## ◆ visit2() [1/2]

void visit2 | ( | OtherRootNodeType & | other,
|  | VisitorOp & | op
| ) |  |
| inline

## ◆ visit2() [2/2]

void visit2 | ( | OtherRootNodeType & | other,
|  | VisitorOp & | op
| ) |  | const
| inline

## ◆ visitActiveBBox()

void visitActiveBBox | ( | BBoxOp & | op | ) | const
| inline

Call the templated functor BBoxOp with bounding box information for all active tiles and leaf nodes in the tree. An additional level argument is provided for each callback.

Note
  The bounding boxes are guaranteed to be non-overlapping.

## ◆ voxelizeActiveTiles()

void voxelizeActiveTiles | ( | bool | threaded = `true` | ) |
| inline

Densify active tiles, i.e., replace them with leaf-level active voxels.

Parameters

  threaded | if true, this operation is multi-threaded (over the internal nodes).

Warning
  This method can explode the tree's memory footprint, especially if it contains active tiles at the upper levels (in particular the root level)!

See also
  denseFill()

## ◆ writeBuffers()

void writeBuffers | ( | std::ostream & | os,
|  | bool | toHalf = `false`
| ) |  | const
| inline

## ◆ writeTopology()

bool writeTopology | ( | std::ostream & | os,
|  | bool | toHalf = `false`
| ) |  | const
| inline

## Friends And Related Function Documentation

## ◆ RootNode

friend class RootNode
| friend

During topology-only construction, access is needed to protected/private members of other template instances.

## ◆ RootNodeCombineHelper

friend struct RootNodeCombineHelper
| friend

## ◆ RootNodeCopyHelper

friend struct RootNodeCopyHelper
| friend

## Member Data Documentation

## ◆ LEVEL

const Index LEVEL = 1 + ChildType::LEVEL
| static

The documentation for this class was generated from the following file:

- RootNode.h